
cannonade = {}

-- For services that handle input, make sure you load them in the order
-- that you want input to be handled (i.e. xz-region-selection gets priority
-- over unit-selection/orders.)
local service_creation_order = {
   'selection'
}

local function create_service(name)
   local path = string.format('services.client.%s.%s_service', name, name)
   local service = require(path)()

   local saved_variables = cannonade._sv[name]
   if not saved_variables then
      saved_variables = radiant.create_datastore()
      cannonade._sv[name] = saved_variables
   end
   service.__saved_variables = saved_variables
   saved_variables:set_controller(service)
   service._sv = saved_variables:get_data()
   service:initialize()
   cannonade[name] = service
end

local function cleanup_entity(entity)
   StonehearthCommon.destroy_child_entities(entity)
   StonehearthCommon.destroy_entity_forms(entity)
end

radiant.events.listen(cannonade, 'radiant:init', function()
   radiant.terrain.initialize(false)
   cannonade._sv = cannonade.__saved_variables:get_data()
      for _, name in ipairs(service_creation_order) do
         create_service(name)
      end

      radiant.events.listen(radiant, 'radiant:entity:pre_destroy', function(e)
            radiant.xpcall(function()
                  cleanup_entity(e.entity)
               end)
         end)
   end)

return cannonade
